const dbConnection = require("../db/connection");
const { logger_data, logger_msg } = require('../config/utils');
require("./globalfuntions.controller");

comprasController = {};

let msgLog = [];

let formaPagoMatrix = [];

let comprasDetalleMatrix = [];

comprasController.compras_loadpage = (req, res) => {
	res.send("API Compras");
};

//* Vista de ordenes de compra
comprasController.compras_view = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const empresa = req.body;
	if (!empresa) {
		msgLog.push("No hay información a solicitar.");
		res.status(200).json(msgLog);
		msgLog.length = 0;
	} else if (empresa) {
		console.log("entra :>> ");
		console.log(empresa.id);
		const queryEmpresa = "SELECT nombreComercial FROM empresas WHERE id= ?;";
		dbConnection.connectionDB.query(queryEmpresa, empresa.id, (error, results) => {
			if (error) {
				globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
				throw error;
			} else if (results.length > 0) {
				globalFunctions.logger(logger_data(req), 'info', logger_msg.info);

				const nombreComercial = results[0].nombreComercial;
				const query_vw_compras = "SELECT * FROM vw_compras WHERE idEmpresas= ?;";

				dbConnection.connectionDB.query(query_vw_compras, nombreComercial, (error, results) => {
					if (error) {
						globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
						throw error;
					} else {
						res.json(results);
					}
				});
			} else {
				res.send("Sin resultados");
			}
		});
	}
}

//* Carga la lista de compras en carrito x usuario, se filtra tambien por idComprasOrdenes ***
comprasController.compras_list = (req, res) => {
	const compras = req.body;
	console.table(compras);
	const query = "SELECT idCompras, idComprasOrdenes,comprasDetalle.idProductos,productos.descLarga,productos.precioCosto,productos.precioPublico,productos.margen," +
		"precioCompra,cantidad,total FROM comprasDetalle LEFT JOIN productos ON productos.id = idProductos WHERE idCompras = 0 AND idUsuarios = ? AND idComprasOrdenes = ?;";
	dbConnection.connectionDB.query(query, [compras.idUsuarios, compras.idComprasOrdenes], (error, results) => {
		if (error) throw error;
		if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

//* Busca un producto por medio del codigo de barras y regresa toda su información
comprasController.compras_sp_barcode = (req, res) => {
	const compras = req.body;
	console.table(compras);
	const query = "CALL sp_buscarIdProducto( ?,?, ?);";
	dbConnection.connectionDB.query(query, [compras.idEmpresas, compras.idSucursales, compras.barcode], (error, results, response) => {
		if (error) throw error;
		if (results.length > 0) {
			res.json(results);
			console.log(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

//* Inserta la informacion detalle de la compra.
comprasController.compras_create_detalle_post = (req, res) => {
	const compras = req.body;
	console.table(compras);
	const query =
		"INSERT INTO comprasDetalle (idCompras,idProductos,precioCompra,cantidad,total,idUsuarios,idComprasOrdenes) VALUES (0,?,?,?,?,?,?);";
	dbConnection.connectionDB.beginTransaction((err) => {
		if (err) {
			console.error("TRANSACTION ERROR :>> ", err);
		} else {
			dbConnection.connectionDB.query(
				query,
				[
					compras.id, //idProducto
					compras.precioCompra,
					compras.cantidad,
					compras.total,
					compras.idUsuarios,
					compras.idComprasOrdenes
				],
				(error, response, result) => {
					if (error) {
						dbConnection.connectionDB.rollback(() => {
							console.log("QUERY > ROLLBACK ERROR INSERT comprasDetalle :>> ", error);
							const status = globalFunctions.statusMsg(0);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						});
					} else if (response) {
						//! Actualizar el precio en tabla de productos - Los mismos productos de comprasOrdenes se ingresan aquí.

						dbConnection.connectionDB.commit((err) => {
							if (err) {
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"COMMIT ERROR ROLLBACK INSERT comprasDetalle :>> ",
										err,
									);
								});
							} else {
								console.log("QUERY RESPONSE :>> ");
								console.log(response);
								const status = globalFunctions.statusMsg(1);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							}
						});
					}
				},
			);
		}
	});
};

//* Update para editar un registro en comprasDetalle
comprasController.compras_update_detalle_post = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		const query = "UPDATE comprasDetalle SET precioCompra = ?, cantidad = ?, total = ? WHERE idComprasOrdenes = ? AND idProductos = ? AND idUsuarios = ? AND idCompras = 0;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						data.precioCosto,
						data.cantidad,
						data.total,
						data.idComprasOrdenes,
						data.idProductos,
						data.idUsuarios
						//data.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenes :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);

							//*  Actualizar en comprasOrdenesDetalle los datos
							const query = "UPDATE comprasOrdenesDetalle SET cantidad = ?, precio = ?, total = ? WHERE idProductos = ? AND idComprasOrdenes = ?;";
							dbConnection.connectionDB.query(query,
								[
									data.cantidad,
									data.precioCosto,
									data.total,
									data.idProductos,
									data.idComprasOrdenes

								], (error, response, result) => {
									if (error) {
										if (error.code == 'ER_DUP_ENTRY') {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenesDetalle :>> ", error);
												const status = globalFunctions.statusMsg(6);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenesDetalle :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										}
									} else if (response) {
										//* ACTUALIZAR AQUI TAMBIEN LOS DATOS EN LA TABLA DE PRODUCTOS 
										const query = "UPDATE productos SET precioCosto = ?, margen = ?, precioPublico = ? WHERE id = ? AND idEmpresas = ?;";
										dbConnection.connectionDB.query(query,
											[
												data.precioCosto,
												data.margen,
												data.precioPublico,
												data.idProductos,
												data.idEmpresas

											], (error, response, result) => {
												if (error) {
													if (error.code == 'ER_DUP_ENTRY') {
														dbConnection.connectionDB.rollback(() => {
															console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
															const status = globalFunctions.statusMsg(6);
															msgLog.length = 0;
															msgLog.push(status);
															res.json(msgLog);
															msgLog.length = 0;
														});
													} else {
														dbConnection.connectionDB.rollback(() => {
															console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
															const status = globalFunctions.statusMsg(0);
															msgLog.length = 0;
															msgLog.push(status);
															res.json(msgLog);
															msgLog.length = 0;
														});
													}
												} else if (response) {

													const montoQuery = "SELECT sum(total) as monto FROM comprasDetalle WHERE idCompras=0 AND idUsuarios=? AND idComprasOrdenes=?;";
													dbConnection.connectionDB.query(montoQuery, [data.idUsuarios, data.idComprasOrdenes], (error, response, result) => {
														if (error) {
															dbConnection.connectionDB.rollback(() => {
																console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
																const status = globalFunctions.statusMsg(0);
																msgLog.length = 0;
																msgLog.push(status);
																res.json(msgLog);
																msgLog.length = 0;
															});
														} else if (response) {
															const monto = response[0].monto;
															const query = "UPDATE comprasOrdenes SET monto=? WHERE id=? AND idEmpresas=?;";
															dbConnection.connectionDB.query(query,
																[
																	monto,
																	data.idComprasOrdenes,
																	data.idEmpresas
																], (error, response, result) => {
																	if (error) {
																		dbConnection.connectionDB.rollback(() => {
																			console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenes monto :>> ", error);
																			const status = globalFunctions.statusMsg(0);
																			msgLog.length = 0;
																			msgLog.push(status);
																			res.json(msgLog);
																			msgLog.length = 0;
																		});
																	} else if (response) {
																		dbConnection.connectionDB.commit((err) => {
																			if (err) {
																				dbConnection.connectionDB.rollback(() => {
																					console.log(
																						"COMMIT ERROR ROLLBACK UPDATE comprasDetalle :>> ",
																						err,
																					);
																				});
																			} else {
																				const status = globalFunctions.statusMsg(1);
																				msgLog.length = 0;
																				msgLog.push(status);
																				res.json(msgLog);
																				msgLog.length = 0;
																			}
																		});
																	}
																}
															);
															// dbConnection.connectionDB.commit((err) => {
															// 	if (err) {
															// 		dbConnection.connectionDB.rollback(() => {
															// 			console.log(
															// 				"COMMIT ERROR ROLLBACK UPDATE comprasDetalle :>> ",
															// 				err,
															// 			);
															// 		});
															// 	} else {
															// 		const status = globalFunctions.statusMsg(1);
															// 		msgLog.length = 0;
															// 		msgLog.push(status);
															// 		res.json(msgLog);
															// 		msgLog.length = 0;
															// 	}
															// });
														}
													}
													);
												}
											}
										);
									}
								}
							);

						}
					},
				);
			}
		});
	}
}

//* Agregar una nueva compra.
comprasController.compras_create_post = (req, res) => {
	let counter = 0;
	let counter2 = 0;
	const compras = req.body;
	if (!compras) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(compras);
		//* Obtener el utlimo ID de tabla compras
		const query = "SELECT CAST(id AS UNSIGNED) + 1 as nuevoID FROM compras ORDER BY id DESC LIMIT 1;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, (error, response, result) => {
					if (error) {
						dbConnection.connectionDB.rollback(() => {
							console.log("QUERY > ROLLBACK ERROR SELECT (LAST ID +1) compras :>> ", error);
							const status = globalFunctions.statusMsg(0);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						});
					} else if (response) {
						console.log(response.length);
						if (response.length == 0) {
							var nuevoID = 1;
						} else {
							var nuevoID = response[0].nuevoID;
						}
						console.log("QUERY RESULT (LAST ID +1) compras :>> ");
						console.log(response);

						//* Obtener el nuevo correlativo y el documento concatenado.
						const query = "SELECT id AS idDocumentosCorrelativos,concat_ws('-', prefijo, serie,idEmpresas) AS documento, CONCAT_WS('-',serie,correlativo) AS correlativo, CAST(correlativo AS UNSIGNED) + 1 AS nuevoCorrelativo FROM documentosCorrelativos WHERE idDocumentos = 2 AND idUsuarios = ?;";
						dbConnection.connectionDB.query(query, [compras.idUsuarios], (error, response, result) => {
							var correlativo = "";
							var documento = "";
							var idDocumentosCorrelativos = 0;
							var nuevoCorrelativo = 0;

							if (error) {
								dbConnection.connectionDB.rollback(() => {
									console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
									const status = globalFunctions.statusMsg(0);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else if (response) {
								console.log(response.length);
								if (response.length == 0) {
									console.log("QUERY > ROLLBACK ERROR SELECT correlativo y documento :>> El usuario no cuenta con documentos correlativos.");

									//!IMPLEMENTAR QUERY PARA CREARLE AL USUARIO UN DOC CORRELATIVO
									const queryPrefijoSerie = "SELECT CONCAT_WS(' ','COMPRAS', roles.descripcion, usuarios.id) AS prefijo, CONCAT_WS(SUBSTRING(roles.descripcion, 1, 1),'C',usuarios.id) AS serie FROM usuarios "
										+ "LEFT JOIN roles ON usuarios.idRoles = roles.id WHERE usuarios.id = ?;";
									dbConnection.connectionDB.query(queryPrefijoSerie, [compras.idUsuarios], (error, response, result) => {
										if (error) {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR SELECT prefijo y serie :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else if (response) {
											const prefijo = response[0].prefijo;
											const serie = response[0].serie;
											//! HACER EL INSERT ACA
											const query = "INSERT INTO documentosCorrelativos (idDocumentos,prefijo,serie,correlativo,idFormatos,idAvailablePrint,idUsuarios,idEmpresas,created_at) VALUES (2,?,?,1,0,1,?,?,CURRENT_TIMESTAMP());";
											dbConnection.connectionDB.query(query, [prefijo, serie, compras.idUsuarios, compras.idEmpresas], (error, response, result) => {
												if (error) {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT Creación del documento correlativo :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												}
											});
											//! Hacer el SELECT nuevamente para sacar documento y correlativo:
											const queryNuevoCorrelativo = "SELECT id AS idDocumentosCorrelativos,concat_ws('-', prefijo, serie,idEmpresas) AS documento,CONCAT_WS('-',serie,correlativo) AS correlativo, CAST(correlativo AS UNSIGNED) + 1 AS nuevoCorrelativo FROM documentosCorrelativos WHERE idDocumentos = 2 AND idUsuarios = ?;";
											dbConnection.connectionDB.query(queryNuevoCorrelativo, [compras.idUsuarios], (error, response, result) => {
												if (error) {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												} else if (response) {
													console.log("QUERY RESPONSE (NUEVO correlativo +1) :>> ");
													console.log(response);
													idDocumentosCorrelativos = response[0].idDocumentosCorrelativos;
													documento = response[0].documento;
													correlativo = response[0].correlativo;
													nuevoCorrelativo = response[0].nuevoCorrelativo;

													//* Insertar los encabezados en la tabla de compras.
													const query = "INSERT INTO compras (id,idDocumentosCorrelativos,correlativo,idProveedores,pequenoContribuyente,idTipoCompra," +
														"conceptoCompra,serieFactura,noFactura,fechaContabilizacion,fechaFactura,fechaPago,valorFactura,subtotal,descuentoP, descuentoM,total,iva,saldo,idUsuarios,idSucursales" +
														",idEmpresas,ingresoA,idPuntoIngreso,generaIva) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);";
													dbConnection.connectionDB.query(query,
														[
															nuevoID,
															idDocumentosCorrelativos, // Tomarlo según del correlativo obtenido
															correlativo,
															compras.idProveedores,
															compras.pequenoContribuyente,
															compras.idTipoCompra,
															compras.conceptoCompra,
															compras.serieFactura,
															compras.noFactura,
															compras.fechaContabilizacion,
															compras.fechaFactura,
															compras.fechaPago,
															compras.valorFactura,
															compras.subtotal,
															compras.desucentoP,
															compras.descuentoM,
															compras.total,
															compras.iva,
															compras.saldo,
															compras.idUsuarios,
															compras.idSucursales,
															compras.idEmpresas,
															compras.ingresoA,
															compras.idPuntoIngreso,
															compras.generaIva
														], (error, response, result) => {
															if (error) {
																if (error.code == 'ER_DUP_ENTRY') {
																	dbConnection.connectionDB.rollback(() => {
																		console.log("QUERY > ROLLBACK ERROR INSERT compras :>> ", error);
																		const status = globalFunctions.statusMsg(6);
																		msgLog.length = 0;
																		msgLog.push(status);
																		res.json(msgLog);
																		msgLog.length = 0;
																	});
																} else {
																	dbConnection.connectionDB.rollback(() => {
																		console.log("QUERY > ROLLBACK ERROR INSERT compras :>> ", error);
																		const status = globalFunctions.statusMsg(0);
																		msgLog.length = 0;
																		msgLog.push(status);
																		res.json(msgLog);
																		msgLog.length = 0;
																	});
																}
															} else if (response) {
																console.log("QUERY RESPONSE INSERT compras :>> ");
																console.log(response);
																//* Actualiza el correlativo en la tabla de documentosCorrelativos. 
																const query = "UPDATE documentosCorrelativos SET correlativo = ? WHERE idDocumentos = 2 AND idUsuarios = ?;";
																dbConnection.connectionDB.query(query,
																	[
																		nuevoCorrelativo,
																		compras.idUsuarios,
																	], (error, response, result) => {
																		if (error) {
																			if (error.code == 'ER_DUP_ENTRY') {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																					const status = globalFunctions.statusMsg(6);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			} else {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE Correlativo :>> ", error);
																					const status = globalFunctions.statusMsg(0);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			}
																		} else if (response) {
																			console.log("QUERY RESPONSE CORRELATIVO :>> ");
																			console.log(response);

																			//* Actualizar el idCompras a todos los productos que tengan 0 en comprasDetalle ***
																			const query = "UPDATE comprasDetalle SET idCompras = ? WHERE idCompras = 0 AND idUsuarios = ? AND idComprasOrdenes = ?;";
																			dbConnection.connectionDB.query(query,
																				[nuevoID, compras.idUsuarios, compras.idComprasOrdenes], (error, response, results) => {
																					if (error) {
																						dbConnection.connectionDB.rollback(() => {
																							console.log("QUERY > ROLLBACK ERROR UPDATE compras detalle :>> ", error);
																							const status = globalFunctions.statusMsg(0);
																							msgLog.length = 0;
																							msgLog.push(status);
																							res.json(msgLog);
																							msgLog.length = 0;
																						});
																					} else if (response) {
																						console.log("QUERY RESPONSE UPDATE compras detalle :>> ");
																						console.log(response);
																						if (response.affectedRows == 0) {
																							dbConnection.connectionDB.rollback(() => {
																								console.log("QUERY > ROLLBACK ERROR UPDATE productos detalle :>> El usuario no cuenta con compras pendientes");
																								const status = globalFunctions.statusMsg(4);
																								msgLog.length = 0;
																								msgLog.push(status);
																								res.json(msgLog);
																								msgLog.length = 0;
																							});
																						} else {

																							//* Ingresa los productos que se compraron como una "ENTRADA" suma de saldo de cada producto.

																							let comprasDetalleMatrix = [...compras.comprasDetalle];
																							console.log(comprasDetalleMatrix);


																							//* Consulta de saldo actual del producto
																							const query = "SELECT * FROM inventarios WHERE idProductos = ? ORDER BY id DESC LIMIT 1;";
																							comprasDetalleMatrix.forEach((arr, index) => {
																								if (![arr].includes(null)) {
																									dbConnection.connectionDB.query(query,
																										[arr.idProductos], (error, response, result) => {
																											if (msgLog.length > 0) {
																												dbConnection.connectionDB.rollback(
																													() => {
																														console.log("ROLLBACK EMPTY FIELDS :>> ");
																														console.log(msgLog);
																														res.json(msgLog);
																														msgLog.length = 0;
																													},
																												);
																											} else {
																												if (error) {
																													dbConnection.connectionDB.rollback(() => {
																														console.log("QUERY > ROLLBACK ERROR INSERT formasPago :>> ", error);
																														const status = globalFunctions.statusMsg(0);
																														msgLog.length = 0;
																														msgLog.push(status);
																														res.json(msgLog);
																														msgLog.length = 0;
																													});
																												} else if (response) {
																													console.log("QUERY RESPONSE SELECT inventario:>> ");
																													console.log(response);
																													var newSaldo = (response[0].saldo + arr.cantidad);
																													const query = `INSERT INTO inventarios (idTipoInventario,ingresoA,idPuntoIngreso,documento,idTipoProductos,idProductos,ingreso,saldo,idUsuarios,idEmpresas) values (1,?,?,?,?,?,?,?,?,?);`;

																													dbConnection.connectionDB.query(query,
																														[compras.ingresoA, compras.idPuntoIngreso, documento, arr.idTipoProductos, arr.id, arr.cantidad,
																															newSaldo, compras.idUsuarios, compras.idEmpresas], (error, response, result) => {
																																if (error) {
																																	dbConnection.connectionDB.rollback(() => {
																																		console.log("QUERY > ROLLBACK ERROR INSERT inventario :>> ", error);
																																		const status = globalFunctions.statusMsg(0);
																																		msgLog.length = 0;
																																		msgLog.push(status);
																																		res.json(msgLog);
																																		msgLog.length = 0;
																																	});
																																} else if (response) {
																																	counter2++;

																																	if (counter2 == comprasDetalleMatrix.length) {

																																		//* Guardar la forma de pago o en credito
																																		formaPagoMatrix = [...compras.formasPago];
																																		console.log(formaPagoMatrix);
																																		if (formaPagoMatrix.length == 0) {

																																			console.log("se pago en crédito");
																																			const query = "INSERT INTO cxp (idProveedores,idCompras,idDocumento,saldo,idUsuarios,idEmpresas) VALUES (?,?,2,?,?,?);";

																																			dbConnection.connectionDB.query(query,
																																				[compras.idProveedores, nuevoID, compras.nuevoSaldo, compras.idUsuarios, compras.idEmpresas], (error, response, result) => {
																																					if (msgLog.length > 0) {
																																						dbConnection.connectionDB.rollback(
																																							() => {
																																								console.log("ROLLBACK EMPTY FIELDS :>> ");
																																								console.log(msgLog);
																																								res.json(msgLog);
																																								msgLog.length = 0;
																																							},
																																						);
																																					} else {
																																						if (error) {
																																							dbConnection.connectionDB.rollback(() => {
																																								console.log("QUERY > ROLLBACK ERROR INSERT cxp :>> ", error);
																																								const status = globalFunctions.statusMsg(0);
																																								msgLog.length = 0;
																																								msgLog.push(status);
																																								res.json(msgLog);
																																								msgLog.length = 0;
																																							});
																																						} else if (response) {
																																							console.log("QUERY RESPONSE INSERT cxp:>> ");
																																							console.log(response);
																																							dbConnection.connectionDB.commit((err) => {
																																								if (err) {
																																									dbConnection.connectionDB.rollback(() => {
																																										console.log(
																																											"COMMIT ERROR ROLLBACK 'INSERT' cxp :>> ",
																																											err,
																																										);
																																										const status = globalFunctions.statusMsg(0);
																																										msgLog.length = 0;
																																										msgLog.push(status);
																																										res.json(msgLog);
																																										msgLog.length = 0;
																																									});
																																								} else {
																																									counter = formaPagoMatrix.length;
																																									if (counter == formaPagoMatrix.length) {
																																										let status;
																																										if (msgLog.length == 0) {
																																											status = globalFunctions.statusMsg(1);
																																											// msgLog.push("Compra cargada correctamente.");
																																											msgLog.push(status);
																																										}
																																										res.json(msgLog);
																																										msgLog.length = 0;
																																									}
																																								}
																																							});
																																						}
																																					}
																																				});

																																		} else {
																																			const query = "INSERT INTO comprasLiquidacion(idCompras, idFormasPago, valor, idEmisores) VALUES (?,?,?,?);";
																																			formaPagoMatrix.forEach((arr, index) => {
																																				if (![arr].includes(null)) {
																																					dbConnection.connectionDB.query(query,
																																						[nuevoID, arr.idFormasPago, arr.valor, arr.idEmisores], (error, response, result) => {
																																							if (msgLog.length > 0) {
																																								dbConnection.connectionDB.rollback(
																																									() => {
																																										console.log("ROLLBACK EMPTY FIELDS :>> ");
																																										console.log(msgLog);
																																										res.json(msgLog);
																																										msgLog.length = 0;
																																									},
																																								);
																																							} else {
																																								if (error) {
																																									dbConnection.connectionDB.rollback(() => {
																																										console.log("QUERY > ROLLBACK ERROR INSERT formasPago :>> ", error);
																																										const status = globalFunctions.statusMsg(0);
																																										msgLog.length = 0;
																																										msgLog.push(status);
																																										res.json(msgLog);
																																										msgLog.length = 0;
																																									});
																																								} else if (response) {
																																									console.log("QUERY RESPONSE INSERT formasPago:>> ");
																																									console.log(response);
																																									dbConnection.connectionDB.commit(
																																										(err) => {
																																											if (err) {
																																												dbConnection.connectionDB.rollback(
																																													() => {
																																														console.log(
																																															"COMMIT ERROR ROLLBACK INSERT compras :>>",
																																															err,
																																														);
																																													},
																																												);
																																											} else {
																																												counter++;
																																												if (counter == formaPagoMatrix.length) {
																																													let status;
																																													if (msgLog.length == 0) {
																																														status = globalFunctions.statusMsg(1);
																																														// msgLog.push("Compra cargada correctamente.");
																																														msgLog.push(status);
																																													}
																																													res.json(msgLog);
																																													msgLog.length = 0;
																																												}
																																											}
																																										},
																																									);
																																								}
																																							}
																																						}
																																					);
																																				}
																																			});
																																		}
																																	}
																																}
																															}
																													);
																												}
																											}
																										}
																									);
																								}
																							});
																						}
																					}
																				},
																			);
																		}
																	}
																);
															}
														},
													);
												}
											});
										}
									});
								} else {
									console.log("QUERY RESPONSE (correlativo +1) :>> ");
									console.log(response);
									documento = response[0].documento;
									correlativo = response[0].correlativo;
									idDocumentosCorrelativos = response[0].idDocumentosCorrelativos;
									nuevoCorrelativo = response[0].nuevoCorrelativo;

									//* Insertar los encabezados en la tabla de ajustes.
									const query = "INSERT INTO compras (id,idDocumentosCorrelativos,correlativo,idProveedores,pequenoContribuyente,idTipoCompra," +
										"conceptoCompra,serieFactura,noFactura,fechaContabilizacion,fechaFactura,fechaPago,valorFactura,subtotal,descuentoP,descuentoM,total,iva,saldo,idUsuarios,idSucursales" +
										",idEmpresas,ingresoA,idPuntoIngreso,generaIva) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);";
									dbConnection.connectionDB.query(query,
										[
											nuevoID,
											idDocumentosCorrelativos,
											correlativo,
											compras.idProveedores,
											compras.pequenoContribuyente,
											compras.idTipoCompra,
											compras.conceptoCompra,
											compras.serieFactura,
											compras.noFactura,
											compras.fechaContabilizacion,
											compras.fechaFactura,
											compras.fechaPago,
											compras.valorFactura,
											compras.subtotal,
											compras.descuentoP,
											compras.desucentoM,
											compras.total,
											compras.iva,
											compras.saldo,
											compras.idUsuarios,
											compras.idSucursales,
											compras.idEmpresas,
											compras.ingresoA,
											compras.idPuntoIngreso,
											compras.generaIva
										], (error, response, result) => {
											if (error) {
												if (error.code == 'ER_DUP_ENTRY') {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT compras :>> ", error);
														const status = globalFunctions.statusMsg(6);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												} else {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT compras :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												}
											} else if (response) {
												console.log("QUERY RESPONSE INSERT compras :>> ");
												console.log(response);
												//* Actualiza el correlativo en la tabla de documentosCorrelativos. 
												const query = "UPDATE documentosCorrelativos SET correlativo = ? WHERE idDocumentos = 2 AND idUsuarios = ?;";
												dbConnection.connectionDB.query(query,
													[
														nuevoCorrelativo,
														compras.idUsuarios,
													], (error, response, result) => {
														if (error) {
															if (error.code == 'ER_DUP_ENTRY') {
																dbConnection.connectionDB.rollback(() => {
																	console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																	const status = globalFunctions.statusMsg(6);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															} else {
																dbConnection.connectionDB.rollback(() => {
																	console.log("QUERY > ROLLBACK ERROR UPDATE Correlativo :>> ", error);
																	const status = globalFunctions.statusMsg(0);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															}
														} else if (response) {
															console.log("QUERY RESPONSE CORRELATIVO :>> ");
															console.log(response);

															//* Actualizar el idCompras a todos los productos que tengan 0 en comprasDetalle
															const query = "UPDATE comprasDetalle SET idCompras = ? WHERE idCompras = 0 AND idUsuarios = ? AND idComprasOrdenes = ?;";
															dbConnection.connectionDB.query(query,
																[nuevoID, compras.idUsuarios, compras.idComprasOrdenes], (error, response, results) => {
																	if (error) {
																		dbConnection.connectionDB.rollback(() => {
																			console.log("QUERY > ROLLBACK ERROR UPDATE compras detalle :>> ", error);
																			const status = globalFunctions.statusMsg(0);
																			msgLog.length = 0;
																			msgLog.push(status);
																			res.json(msgLog);
																			msgLog.length = 0;
																		});
																	} else if (response) {
																		console.log("QUERY RESPONSE UPDATE compras detalle :>> ");
																		console.log(response);
																		if (response.affectedRows == 0) {
																			dbConnection.connectionDB.rollback(() => {
																				console.log("QUERY > ROLLBACK ERROR UPDATE productos detalle :>> El usuario no cuenta con compras pendientes");
																				const status = globalFunctions.statusMsg(4);
																				msgLog.length = 0;
																				msgLog.push(status);
																				res.json(msgLog);
																				msgLog.length = 0;
																			});
																		} else {
																			//* Ingresa los productos que se compraron como una "ENTRADA" suma de saldo de cada producto.

																			let comprasDetalleMatrix = [...compras.comprasDetalle];
																			console.log(comprasDetalleMatrix);

																			//* Consulta de saldo actual del producto
																			const query = "SELECT * FROM inventarios WHERE idProductos = ? ORDER BY id DESC LIMIT 1;";
																			comprasDetalleMatrix.forEach((arr, index) => {
																				if (![arr].includes(null)) {
																					dbConnection.connectionDB.query(query,
																						[arr.idProductos], (error, response, result) => {
																							if (msgLog.length > 0) {
																								dbConnection.connectionDB.rollback(
																									() => {
																										console.log("ROLLBACK EMPTY FIELDS :>> ");
																										console.log(msgLog);
																										res.json(msgLog);
																										msgLog.length = 0;
																									},
																								);
																							} else {
																								if (error) {
																									dbConnection.connectionDB.rollback(() => {
																										console.log("QUERY > ROLLBACK ERROR INSERT formasPago :>> ", error);
																										const status = globalFunctions.statusMsg(0);
																										msgLog.length = 0;
																										msgLog.push(status);
																										res.json(msgLog);
																										msgLog.length = 0;
																									});
																								} else if (response) {
																									console.log("QUERY RESPONSE SELECT inventario:>> ");
																									console.log(response);
																									var newSaldo = (response[0].saldo + arr.cantidad);
																									const query = `INSERT INTO inventarios (idTipoInventario,ingresoA,idPuntoIngreso,documento,idTipoProductos,idProductos,ingreso,saldo,idUsuarios,idEmpresas) values (1,?,?,?,?,?,?,?,?,?);`;

																									dbConnection.connectionDB.query(query,
																										[compras.ingresoA, compras.idPuntoIngreso, documento, arr.idTipoProductos, arr.idProductos, arr.cantidad,
																											newSaldo, compras.idUsuarios, compras.idEmpresas], (error, response, result) => {
																												if (error) {
																													dbConnection.connectionDB.rollback(() => {
																														console.log("QUERY > ROLLBACK ERROR INSERT inventario :>> ", error);
																														const status = globalFunctions.statusMsg(0);
																														msgLog.length = 0;
																														msgLog.push(status);
																														res.json(msgLog);
																														msgLog.length = 0;
																													});
																												} else if (response) {
																													counter2++;
																													if (counter2 == comprasDetalleMatrix.length) {
																														//* Guardar la forma de pago o en credito


																														formaPagoMatrix = [...compras.formasPago];
																														console.log("MATRIX FORMAS PAGO: ", formaPagoMatrix);


																														if (formaPagoMatrix.length == 0) {

																															console.log("se pago en crédito");
																															const query = "INSERT INTO cxp (idProveedores,idCompras,idDocumento,saldo,idUsuarios,idEmpresas) VALUES (?,?,2,?,?,?);";

																															dbConnection.connectionDB.query(query,
																																[compras.idProveedores, nuevoID, compras.nuevoSaldo, compras.idUsuarios, compras.idEmpresas], (error, response, result) => {
																																	if (msgLog.length > 0) {
																																		dbConnection.connectionDB.rollback(
																																			() => {
																																				console.log("ROLLBACK EMPTY FIELDS :>> ");
																																				console.log(msgLog);
																																				res.json(msgLog);
																																				msgLog.length = 0;
																																			},
																																		);
																																	} else {
																																		if (error) {
																																			dbConnection.connectionDB.rollback(() => {
																																				console.log("QUERY > ROLLBACK ERROR INSERT cxp :>> ", error);
																																				const status = globalFunctions.statusMsg(0);
																																				msgLog.length = 0;
																																				msgLog.push(status);
																																				res.json(msgLog);
																																				msgLog.length = 0;
																																			});
																																		} else if (response) {
																																			console.log("QUERY RESPONSE INSERT cxp:>> ");
																																			console.log(response);
																																			dbConnection.connectionDB.commit((err) => {
																																				if (err) {
																																					dbConnection.connectionDB.rollback(() => {
																																						console.log(
																																							"COMMIT ERROR ROLLBACK 'INSERT' cxp :>> ",
																																							err,
																																						);
																																						const status = globalFunctions.statusMsg(0);
																																						msgLog.length = 0;
																																						msgLog.push(status);
																																						res.json(msgLog);
																																						msgLog.length = 0;
																																					});
																																				} else {
																																					counter = formaPagoMatrix.length;
																																					if (counter == formaPagoMatrix.length) {
																																						let status;
																																						if (msgLog.length == 0) {
																																							status = globalFunctions.statusMsg(1);
																																							// msgLog.push("Compra cargada correctamente.");
																																							msgLog.push(status);
																																						}
																																						res.json(msgLog);
																																						msgLog.length = 0;
																																					}
																																				}
																																			});
																																		}
																																	}
																																});

																														} else {
																															const query = "INSERT INTO comprasLiquidacion(idCompras, idFormasPago, valor, idEmisores) VALUES (?,?,?,?);";
																															formaPagoMatrix.forEach((arr, index) => {
																																if (![arr].includes(null)) {
																																	dbConnection.connectionDB.query(query,
																																		[nuevoID, arr.idFormasPago, arr.valor, arr.idEmisores], (error, response, result) => {
																																			if (msgLog.length > 0) {
																																				dbConnection.connectionDB.rollback(
																																					() => {
																																						console.log("ROLLBACK EMPTY FIELDS :>> ");
																																						console.log(msgLog);
																																						res.json(msgLog);
																																						msgLog.length = 0;
																																					},
																																				);
																																			} else {
																																				if (error) {
																																					dbConnection.connectionDB.rollback(() => {
																																						console.log("QUERY > ROLLBACK ERROR INSERT formasPago :>> ", error);
																																						const status = globalFunctions.statusMsg(0);
																																						msgLog.length = 0;
																																						msgLog.push(status);
																																						res.json(msgLog);
																																						msgLog.length = 0;
																																					});
																																				} else if (response) {
																																					console.log("QUERY RESPONSE INSERT formasPago:>> ");
																																					console.log(response);
																																					dbConnection.connectionDB.commit(
																																						(err) => {
																																							if (err) {
																																								dbConnection.connectionDB.rollback(
																																									() => {
																																										console.log(
																																											"COMMIT ERROR ROLLBACK INSERT compras :>>",
																																											err,
																																										);
																																									},
																																								);
																																							} else {
																																								counter++;
																																								/*
																																								if (counter == formaPagoMatrix.length) {
																																									if (msgLog.length == 0) {
																																										msgLog.push("Compra cargada correctamente.");
																																									}
																																									console.log(msgLog);
																																									res.json(msgLog);
																																									msgLog.length = 0;
																																								}
																																								*/


																																								if (counter == formaPagoMatrix.length) {
																																									let status;
																																									if (msgLog.length == 0) {
																																										status = globalFunctions.statusMsg(1);
																																										// msgLog.push("Compra cargada correctamente.");
																																										msgLog.push(status);
																																									}
																																									res.json(msgLog);
																																									msgLog.length = 0;
																																								}

																																							}
																																						},
																																					);
																																				}
																																			}
																																		}
																																	);
																																}
																															});
																														}
																													}
																												}
																											}
																									);

																								}
																							}
																						});
																				}
																			}
																			);
																		}
																	}
																},
															);
														}
													}
												);
											}
										},
									);
								}
							}
						});
					}
				});
			}
		});
	}
};

//* Eliminar un producto en carrito de la compra.
comprasController.compras_delete_detalle = (req, res) => {
	const compras = req.body;
	if (!compras) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(compras);
		const query = "DELETE FROM comprasDetalle WHERE idCompras = 0 AND idProductos = ? AND idUsuarios = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [compras.idProductos, compras.idUsuarios],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' comprasDetalle :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							if (response.affectedRows == 0) {
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"COMMIT ERROR ROLLBACK 'DELETE' comprasDetalle :>> No se encontraron resultados "
									);
									const status = globalFunctions.statusMsg(4);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else {
								//* Ir a eliminar a la tabla de comprasOrdenesDetalle
								const query = "DELETE FROM comprasOrdenesDetalle WHERE idComprasOrdenes = ? AND idProductos = ? AND idUsuarios = ?;";
								dbConnection.connectionDB.query(query,
									[
										compras.idComprasOrdenes,
										compras.idProductos,
										compras.idUsuarios
									],
									(error, response, result) => {
										if (error) {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR DELETE comprasDetalle :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else if (response) {
											console.log(response);
											const montoQuery = "SELECT sum(total) as monto FROM comprasDetalle WHERE idCompras=0 AND idUsuarios=? AND idComprasOrdenes=?;";
											dbConnection.connectionDB.query(montoQuery, [compras.idUsuarios, compras.idComprasOrdenes], (error, response, result) => {
												if (error) {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR UPDATE productos :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												} else if (response) {
													const monto = response[0].monto;
													const query = "UPDATE comprasOrdenes SET monto=? WHERE id=? AND idEmpresas=?;";
													dbConnection.connectionDB.query(query,
														[
															monto,
															compras.idComprasOrdenes,
															compras.idEmpresas
														], (error, response, result) => {
															if (error) {
																dbConnection.connectionDB.rollback(() => {
																	console.log("QUERY > ROLLBACK ERROR UPDATE comprasOrdenes monto :>> ", error);
																	const status = globalFunctions.statusMsg(0);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															} else if (response) {
																dbConnection.connectionDB.commit((err) => {
																	if (err) {
																		dbConnection.connectionDB.rollback(() => {
																			console.log(
																				"COMMIT ERROR ROLLBACK 'DELETE' comprasDetalle :>> ",
																				err,
																			);
																			const status = globalFunctions.statusMsg(0);
																			msgLog.length = 0;
																			msgLog.push(status);
																			res.json(msgLog);
																			msgLog.length = 0;
																		});
																	} else {
																		console.log("Compra detalle eliminada con exito");
																		const status = globalFunctions.statusMsg(1);
																		msgLog.length = 0;
																		msgLog.push(status);
																		res.json(msgLog);
																		msgLog.length = 0;
																	}
																});
															}
														}
													);
												}
											}
											);

											// dbConnection.connectionDB.commit((err) => {
											// 	if (err) {
											// 		dbConnection.connectionDB.rollback(() => {
											// 			console.log(
											// 				"COMMIT ERROR ROLLBACK 'DELETE' comprasDetalle :>> ",
											// 				err,
											// 			);
											// 			const status = globalFunctions.statusMsg(0);
											// 			msgLog.length = 0;
											// 			msgLog.push(status);
											// 			res.json(msgLog);
											// 			msgLog.length = 0;
											// 		});
											// 	} else {
											// 		console.log("Compra detalle eliminada con exito");
											// 		const status = globalFunctions.statusMsg(1);
											// 		msgLog.length = 0;
											// 		msgLog.push(status);
											// 		res.json(msgLog);
											// 		msgLog.length = 0;
											// 	}
											// });
										}
									});




							}
						}
					},
				);
			}
		});
	}
};

//* Eliminacion de una compra. -> Eliminacion de su respectivo ingreso en comprasDetalle y la resta de los productos ingresados en el inventario.
comprasController.compras_delete_post = (req, res) => {
	let counter2 = 0;
	const compras = req.body;
	if (!compras) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(compras);
		//* Obtener ingreso y puntoIngreso de la compra
		const query = "SELECT ingresoA, idPuntoIngreso FROM compras WHERE id = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			var ingresoA = 0;
			var idPuntoIngreso = 0;
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [compras.id, compras.idUsuarios],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' COMPRAS :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							if (response.length == 0) {
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"COMMIT ERROR ROLLBACK 'SELECT' IngresoA, idPuntoIngreso :>> No se encontraron resultados "
									);
									const status = globalFunctions.statusMsg(4);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else {
								console.log("Response ingresoA - idPuntoIngreso -> ", response);
								ingresoA = response[0].ingresoA;
								idPuntoIngreso = response[0].idPuntoIngreso;

								//* Obtener los productos de esa compra y su cantidad:
								const query = "SELECT idProductos,cantidad,productos.idTipoProductos FROM comprasDetalle" +
									" LEFT JOIN productos ON productos.id = idProductos" +
									" WHERE idCompras = ? AND idUsuarios = ?;";
								dbConnection.connectionDB.query(query, [compras.id, compras.idUsuarios],
									(error, response, result) => {
										if (error) {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR 'SELECT' productosCompras :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else if (response) {
											if (response.length == 0) {
												dbConnection.connectionDB.rollback(() => {
													console.log(
														"COMMIT ERROR ROLLBACK 'SELECT' COMPRAS :>> No se encontraron resultados "
													);
													const status = globalFunctions.statusMsg(4);
													msgLog.length = 0;
													msgLog.push(status);
													res.json(msgLog);
													msgLog.length = 0;
												});
											} else {
												//* GUARDAR RESULTADOS EN UN ARRAY PARA CONSUMIRLO DESPUES:
												var data = JSON.stringify(response);
												var data2 = JSON.parse(data);
												console.log("Productos de la compra a eliminar: ", data2);

												//* Obtener documento y nuevo correlativo de usuario.
												const query = "SELECT id AS idDocumentosCorrelativos,concat_ws('-', prefijo, serie,idEmpresas) AS documento,CONCAT_WS('-',serie,correlativo) AS correlativo, CAST(correlativo AS UNSIGNED) + 1 AS nuevoCorrelativo FROM documentosCorrelativos WHERE idDocumentos = 22 AND idUsuarios = ?;";
												dbConnection.connectionDB.query(query, [compras.idUsuarios],
													(error, response, result) => {
														var documento = "";
														var nuevoCorrelativo = 0;
														if (error) {
															dbConnection.connectionDB.rollback(() => {
																console.log("QUERY > ROLLBACK ERROR 'SELECT' documento y correlativo :>> ", error);
																const status = globalFunctions.statusMsg(0);
																msgLog.length = 0;
																msgLog.push(status);
																res.json(msgLog);
																msgLog.length = 0;
															});
														} else if (response) {
															if (response.length == 0) {
																console.log("QUERY > ROLLBACK ERROR SELECT correlativo y documento :>> El usuario no cuenta con documentos correlativos.");
																//!IMPLEMENTAR QUERY PARA CREARLE AL USUARIO UN DOC CORRELATIVO
																const queryPrefijoSerie = "SELECT CONCAT_WS(' ','ANULACION DE COMPRAS', roles.descripcion, usuarios.id) AS prefijo, CONCAT_WS(SUBSTRING(roles.descripcion, 1, 1),'AC',usuarios.id) AS serie FROM usuarios "
																	+ "LEFT JOIN roles ON usuarios.idRoles = roles.id WHERE usuarios.id = ?;";
																dbConnection.connectionDB.query(queryPrefijoSerie, [compras.idUsuarios], (error, response, result) => {
																	if (error) {
																		dbConnection.connectionDB.rollback(() => {
																			console.log("QUERY > ROLLBACK ERROR SELECT prefijo y serie :>> ", error);
																			const status = globalFunctions.statusMsg(0);
																			msgLog.length = 0;
																			msgLog.push(status);
																			res.json(msgLog);
																			msgLog.length = 0;
																		});
																	} else if (response) {
																		const prefijo = response[0].prefijo;
																		const serie = response[0].serie;
																		console.log(prefijo, serie);
																		//! HACER EL INSERT 
																		const queryCorrelat = "INSERT INTO documentosCorrelativos (idDocumentos,prefijo,serie,correlativo,idFormatos,idAvailablePrint,idUsuarios,idEmpresas,created_at) VALUES (22,?,?,1,0,1,?,?,CURRENT_TIMESTAMP());";
																		dbConnection.connectionDB.query(queryCorrelat, [prefijo, serie, compras.idUsuarios, compras.idEmpresas], (error, response, result) => {
																			if (error) {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR INSERT Creación del documento correlativo :>> ", error);
																					const status = globalFunctions.statusMsg(0);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			}
																		});
																		//! Hacer el SELECT nuevamente para sacar documento y correlativo:
																		const query2 = "SELECT id AS idDocumentosCorrelativos,concat_ws('-', prefijo, serie,idEmpresas) AS documento,CONCAT_WS('-',serie,correlativo) AS correlativo, " +
																			"CAST(correlativo AS UNSIGNED) + 1 AS nuevoCorrelativo FROM documentosCorrelativos WHERE idDocumentos = 22 AND idUsuarios = ?;";
																		dbConnection.connectionDB.query(query2, [compras.idUsuarios], (error, response, result) => {
																			if (error) {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
																					const status = globalFunctions.statusMsg(0);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			} else if (response) {
																				console.log("QUERY RESPONSE (NUEVO correlativo +1) :>> ");
																				console.log(response);
																				documento = response[0].documento;
																				nuevoCorrelativo = response[0].nuevoCorrelativo;

																				//* Eliminar el registro en la tabla de compras:
																				//* Update para cambiar el status de la compra a "anulada" y agregar el motivo de la anulación
																				//const queryDelete = "DELETE FROM compras WHERE id = ? AND idUsuarios = ?;";
																				const queryDelete = "UPDATE compras SET anulacion = 1, idAdminUser = ?, motivoAnulacion = ?, anulacion_at = CURRENT_TIMESTAMP() WHERE id = ?;";
																				dbConnection.connectionDB.query(queryDelete, [compras.idUsuarios, compras.motivoAnulacion, compras.id], (error, response, result) => {
																					if (error) {
																						dbConnection.connectionDB.rollback(() => {
																							console.log("QUERY > ROLLBACK ERROR SELECT ingresoA, idPuntoIngreso :>> ", error);
																							const status = globalFunctions.statusMsg(0);
																							msgLog.length = 0;
																							msgLog.push(status);
																							res.json(msgLog);
																							msgLog.length = 0;
																						});
																					} else if (response) {
																						console.log("Response: ", response);
																						// ARRAY DE RESULTADOS POR LA CONSULTA DE TABLA INVENTARIOS
																						let eliminarProductosMatrix = [...data2];
																						console.log("JSON: ", eliminarProductosMatrix);

																						//* Consulta de saldo actual del producto
																						const query = "SELECT * FROM inventarios WHERE idProductos = ? ORDER BY id DESC LIMIT 1;";
																						eliminarProductosMatrix.forEach((arr, index) => {
																							if (![arr].includes(null)) {
																								dbConnection.connectionDB.query(query,
																									[arr.idProductos], (error, response, result) => {
																										if (msgLog.length > 0) {
																											dbConnection.connectionDB.rollback(
																												() => {
																													console.log("ROLLBACK EMPTY FIELDS :>> ");
																													console.log(msgLog);
																													res.json(msgLog);
																													msgLog.length = 0;
																												},
																											);
																										} else {
																											if (error) {
																												dbConnection.connectionDB.rollback(() => {
																													console.log("QUERY > ROLLBACK ERROR SELECT inventario :>> ", error);
																													const status = globalFunctions.statusMsg(0);
																													msgLog.length = 0;
																													msgLog.push(status);
																													res.json(msgLog);
																													msgLog.length = 0;
																												});
																											} else if (response) {
																												//* Restarlos en la tabla de inventarios.
																												console.log("QUERY RESPONSE SELECT inventario:>> ");
																												console.log(response);
																												var newSaldo = (response[0].saldo - arr.cantidad);
																												console.log(arr.cantidad);
																												console.log(arr.idProductos);
																												const query = `INSERT INTO inventarios (idTipoInventario,ingresoA,idPuntoIngreso,documento,idTipoProductos,idProductos,salida,saldo,idUsuarios,idEmpresas) values (1,?,?,?,?,?,?,?,?,?);`;
																												//! arr.idTipoProducto
																												dbConnection.connectionDB.query(query,
																													[ingresoA, idPuntoIngreso, documento, arr.idTipoProductos, arr.idProductos, arr.cantidad,
																														newSaldo, compras.idUsuarios, compras.idEmpresas], (error, response, result) => {
																															if (error) {
																																dbConnection.connectionDB.rollback(() => {
																																	console.log("QUERY > ROLLBACK ERROR INSERT inventario :>> ", error);
																																	const status = globalFunctions.statusMsg(0);
																																	msgLog.length = 0;
																																	msgLog.push(status);
																																	res.json(msgLog);
																																	msgLog.length = 0;
																																});
																															} else if (response) {
																																counter2++;
																																if (counter2 == eliminarProductosMatrix.length) {
																																	//* Actualizar el correlativo de ANULACION DE COMPRA:
																																	const queryCorrelativos = "UPDATE documentosCorrelativos SET correlativo = ? WHERE idDocumentos = 22 AND idUsuarios = ?;";
																																	dbConnection.connectionDB.query(queryCorrelativos,
																																		[
																																			nuevoCorrelativo,
																																			compras.idUsuarios,
																																			//idEmpresas
																																		], (error, response, result) => {
																																			if (error) {
																																				if (error.code == 'ER_DUP_ENTRY') {
																																					dbConnection.connectionDB.rollback(() => {
																																						console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																																						const status = globalFunctions.statusMsg(6);
																																						msgLog.length = 0;
																																						msgLog.push(status);
																																						res.json(msgLog);
																																						msgLog.length = 0;
																																					});
																																				} else {
																																					dbConnection.connectionDB.rollback(() => {
																																						console.log("QUERY > ROLLBACK ERROR UPDATE Correlativo :>> ", error);
																																						const status = globalFunctions.statusMsg(0);
																																						msgLog.length = 0;
																																						msgLog.push(status);
																																						res.json(msgLog);
																																						msgLog.length = 0;
																																					});
																																				}
																																			} else if (response) {
																																				//* Eliminar los registros en comprasDetalle
																																				const query = `DELETE FROM comprasDetalle WHERE idCompras = ? AND idUsuarios = ?;`;
																																				dbConnection.connectionDB.query(query,
																																					[compras.id, compras.idUsuarios], (error, response, result) => {
																																						if (error) {
																																							dbConnection.connectionDB.rollback(() => {
																																								console.log("QUERY > ROLLBACK ERROR DELETE comprasDetalle :>> ", error);
																																								const status = globalFunctions.statusMsg(0);
																																								msgLog.length = 0;
																																								msgLog.push(status);
																																								res.json(msgLog);
																																								msgLog.length = 0;
																																							});
																																						} else if (response) {
																																							dbConnection.connectionDB.commit((err) => {
																																								if (err) {
																																									dbConnection.connectionDB.rollback(() => {
																																										console.log(
																																											"COMMIT ERROR ROLLBACK 'DELETE' compra :>> ",
																																											err,
																																										);
																																										const status = globalFunctions.statusMsg(0);
																																										msgLog.length = 0;
																																										msgLog.push(status);
																																										res.json(msgLog);
																																										msgLog.length = 0;
																																									});
																																								} else {
																																									console.log("Compra eliminada con exito");
																																									const status = globalFunctions.statusMsg(1);
																																									msgLog.length = 0;
																																									msgLog.push(status);
																																									res.json(msgLog);
																																									msgLog.length = 0;
																																								}
																																							});
																																						}
																																					}
																																				);
																																			}
																																		}
																																	);
																																}
																															}
																														}
																												)
																											};
																										}
																									}
																								)
																							};
																						});
																					}
																				});
																			}
																		});
																	}
																});
															} else {
																console.log("QUERY RESPONSE (NUEVO correlativo +1) :>> ");
																console.log(response);
																documento = response[0].documento;
																nuevoCorrelativo = response[0].nuevoCorrelativo;

																//* Eliminar el registro en la tabla de compras:
																//const queryDelete = "DELETE FROM compras WHERE id = ? AND idUsuarios = ?;";
																const queryDelete = "UPDATE compras SET anulacion = 1, idAdminUser = ?, motivoAnulacion = ?, anulacion_at = CURRENT_TIMESTAMP() WHERE id = ?;";
																dbConnection.connectionDB.query(queryDelete, [compras.idUsuarios, compras.motivoAnulacion, compras.id], (error, response, result) => {
																	if (error) {
																		dbConnection.connectionDB.rollback(() => {
																			console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
																			const status = globalFunctions.statusMsg(0);
																			msgLog.length = 0;
																			msgLog.push(status);
																			res.json(msgLog);
																			msgLog.length = 0;
																		});
																	} else if (response) {
																		console.log("Response-> ", response);
																		//! ARRAY DE RESULTADOS POR LA CONSULTA DE TABLA INVENTARIOS
																		let eliminarProductosMatrix = [...data2];
																		console.log(eliminarProductosMatrix);

																		//* Consulta de saldo actual del producto
																		const query = "SELECT * FROM inventarios WHERE idProductos = ? ORDER BY id DESC LIMIT 1;";
																		eliminarProductosMatrix.forEach((arr, index) => {
																			if (![arr].includes(null)) {
																				dbConnection.connectionDB.query(query,
																					[arr.idProductos], (error, response, result) => {
																						if (msgLog.length > 0) {
																							dbConnection.connectionDB.rollback(
																								() => {
																									console.log("ROLLBACK EMPTY FIELDS :>> ");
																									console.log(msgLog);
																									res.json(msgLog);
																									msgLog.length = 0;
																								},
																							);
																						} else {
																							if (error) {
																								dbConnection.connectionDB.rollback(() => {
																									console.log("QUERY > ROLLBACK ERROR SELECT inventario :>> ", error);
																									const status = globalFunctions.statusMsg(0);
																									msgLog.length = 0;
																									msgLog.push(status);
																									res.json(msgLog);
																									msgLog.length = 0;
																								});
																							} else if (response) {
																								//* Restarlos en la tabla de inventarios.
																								console.log("QUERY RESPONSE SELECT inventario:>> ");
																								console.log(response);
																								var newSaldo = (response[0].saldo - arr.cantidad);
																								const query = `INSERT INTO inventarios (idTipoInventario,ingresoA,idPuntoIngreso,documento,idTipoProductos,idProductos,salida,saldo,idUsuarios,idEmpresas) values (1,?,?,?,?,?,?,?,?,?);`;
																								//! arr.idTipoProducto
																								dbConnection.connectionDB.query(query,
																									[ingresoA, idPuntoIngreso, documento, arr.idTipoProductos, arr.idProductos, arr.cantidad,
																										newSaldo, compras.idUsuarios, compras.idEmpresas], (error, response, result) => {
																											if (error) {
																												dbConnection.connectionDB.rollback(() => {
																													console.log("QUERY > ROLLBACK ERROR INSERT inventario :>> ", error);
																													const status = globalFunctions.statusMsg(0);
																													msgLog.length = 0;
																													msgLog.push(status);
																													res.json(msgLog);
																													msgLog.length = 0;
																												});
																											} else if (response) {
																												counter2++;
																												if (counter2 == eliminarProductosMatrix.length) {
																													//* Actualizar el correlativo de ANULACION DE COMPRA:
																													const queryCorrelativos = "UPDATE documentosCorrelativos SET correlativo = ? WHERE idDocumentos = 22 AND idUsuarios = ?;";
																													dbConnection.connectionDB.query(queryCorrelativos,
																														[
																															nuevoCorrelativo,
																															compras.idUsuarios,
																															//idEmpresas
																														], (error, response, result) => {
																															if (error) {
																																if (error.code == 'ER_DUP_ENTRY') {
																																	dbConnection.connectionDB.rollback(() => {
																																		console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																																		const status = globalFunctions.statusMsg(6);
																																		msgLog.length = 0;
																																		msgLog.push(status);
																																		res.json(msgLog);
																																		msgLog.length = 0;
																																	});
																																} else {
																																	dbConnection.connectionDB.rollback(() => {
																																		console.log("QUERY > ROLLBACK ERROR UPDATE Correlativo :>> ", error);
																																		const status = globalFunctions.statusMsg(0);
																																		msgLog.length = 0;
																																		msgLog.push(status);
																																		res.json(msgLog);
																																		msgLog.length = 0;
																																	});
																																}
																															} else if (response) {
																																//* Eliminar los registros en comprasDetalle
																																const query = `DELETE FROM comprasDetalle WHERE idCompras = ? AND idUsuarios = ?;`;
																																dbConnection.connectionDB.query(query,
																																	[compras.id, compras.idUsuarios], (error, response, result) => {
																																		if (error) {
																																			dbConnection.connectionDB.rollback(() => {
																																				console.log("QUERY > ROLLBACK ERROR DELETE comprasDetalle :>> ", error);
																																				const status = globalFunctions.statusMsg(0);
																																				msgLog.length = 0;
																																				msgLog.push(status);
																																				res.json(msgLog);
																																				msgLog.length = 0;
																																			});
																																		} else if (response) {
																																			dbConnection.connectionDB.commit((err) => {
																																				if (err) {
																																					dbConnection.connectionDB.rollback(() => {
																																						console.log(
																																							"COMMIT ERROR ROLLBACK 'DELETE' compra :>> ",
																																							err,
																																						);
																																						const status = globalFunctions.statusMsg(0);
																																						msgLog.length = 0;
																																						msgLog.push(status);
																																						res.json(msgLog);
																																						msgLog.length = 0;
																																					});
																																				} else {
																																					console.log("Compra eliminada con exito");
																																					const status = globalFunctions.statusMsg(1);
																																					msgLog.length = 0;
																																					msgLog.push(status);
																																					res.json(msgLog);
																																					msgLog.length = 0;
																																				}
																																			});
																																		}
																																	}
																																);
																															}
																														}
																													);
																												}
																											}
																										}
																								)
																							};
																						}
																					}
																				)
																			};
																		});
																	}
																});
															}
														}
													}
												);
											}
										}
									}
								);
							}
						}
					}
				);
			}
		})
	}
};

module.exports.comprasController = comprasController;
