const dbConnection = require("../db/connection");
require("./globalfuntions.controller");
const { logger_data, logger_msg } = require('../config/utils');

familia_nivel_2_Controller = {};
let msgLog = [];



familia_nivel_2_Controller.loadpage = (req, res) => {
    res.send("API familiaNivel2");
}

familia_nivel_2_Controller.familia_nivel_2_list = (req, res) => {
    const query = "SELECT fn2.*, fn1.descripcion AS idFamiliaNivel1Desc, n.descripcion AS idNomenclaturaDesc, c.descripcion AS idCentrosCostoDesc FROM familiaNivel2 fn2 LEFT JOIN familiaNivel1 fn1 ON fn2.idFamiliaNivel1 = fn1.id LEFT JOIN nomenclatura n ON fn2.idNomenclatura = n.id LEFT JOIN centrosCosto c ON fn2.idCentrosCosto = c.id WHERE fn2.idEmpresas=1;";
    dbConnection.connectionDB.query(query, (error, response, results) => {
        if (error) {
            console.log(error);
            const status = globalFunctions.statusMsg(0);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else if (response) {
            res.json(response);
        } else {
            const status = globalFunctions.statusMsg(4);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        }
    });
}

familia_nivel_2_Controller.familia_nivel_2_detail = (req, res) => {
    const f = req.body;
    const query = "SELECT * FROM familiaNivel2 WHERE idFamiliaNivel1 = ? AND idEmpresas = ?;";
    dbConnection.connectionDB.query(query, [f.idFamiliaNivel1, f.idEmpresas], (error, response, results) => {
        if (error) {
            console.log(error);
            const status = globalFunctions.statusMsg(0);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else if (response) {
            res.json(response);
        } else {
            const status = globalFunctions.statusMsg(4);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        }
    });
}

// elimina un dato de la base
familia_nivel_2_Controller.familia_nivel_2_delete = (req, res) => {
    const familia_nivel_2 = req.body;
    if (!familia_nivel_2) {
        const status = globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {
        console.table(familia_nivel_2);
        const query = "DELETE FROM familiaNivel2 WHERE id = ? and idEmpresas = ?;";
        dbConnection.connectionDB.beginTransaction((err) => {
            if (err) {
                console.error("TRANSACTION ERROR :>> ", err);
            } else {
                dbConnection.connectionDB.query(query, [familia_nivel_2.id, familia_nivel_2.idEmpresas],
                    (error, response, result) => {
                        if (error) {
                            dbConnection.connectionDB.rollback(() => {
                                console.log("QUERY > ROLLBACK ERROR 'DELETE' familiaNivel2 :>> ", error);
                                const status = globalFunctions.statusMsg(0);
                                msgLog.length = 0;
                                msgLog.push(status);
                                res.json(msgLog);
                                msgLog.length = 0;
                            });
                        } else if (response) {
                            console.log("QUERY RESPONSE :>> ");
                            console.log(response);
                            /*
							console.log("QUERY RESULT :>> ");
							console.log(result);
                            */
                            dbConnection.connectionDB.commit((err) => {
                                if (err) {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log(
                                            "COMMIT ERROR ROLLBACK 'DELETE' familiaNivel2 :>> ",
                                            err,
                                        );
                                        const status = globalFunctions.statusMsg(0);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                } else {
                                    const status = globalFunctions.statusMsg(1);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                }
                            });
                        } else {
                            const status = globalFunctions.statusMsg(4);
                            msgLog.length = 0;
                            msgLog.push(status);
                            res.json(msgLog);
                            msgLog.length = 0;
                        }
                    },
                );
            }
        });
    }
}

// crear un dato en la base
familia_nivel_2_Controller.familia_nivel_2_create = (req, res) => {
    const familia_nivel_2 = req.body;
    console.table(familia_nivel_2);
    const query =
        "INSERT INTO familiaNivel2 (descripcion, idFamiliaNivel1, idNomenclatura, idCentrosCosto, idEmpresas, created_at) VALUES( ?, ?, ?, ?, ?, CURRENT_TIMESTAMP());";

    dbConnection.connectionDB.beginTransaction((err) => {
        if (err) {
            console.error("TRANSACTION ERROR :>> ", err);
        } else {
            dbConnection.connectionDB.query(
                query, [
                    familia_nivel_2.descripcion,
                    familia_nivel_2.idFamiliaNivel1,
                    familia_nivel_2.idNomenclatura,
                    familia_nivel_2.idCentrosCosto,
                    familia_nivel_2.idEmpresas,
                ],
                (error, response, result) => {
                    if (error) {
                        dbConnection.connectionDB.rollback(() => {
                            console.log("QUERY > ROLLBACK ERROR INSERT familiaNivel2 :>> ", error);
                            const status = globalFunctions.statusMsg(0);
                            msgLog.length = 0;
                            msgLog.push(status);
                            res.json(msgLog);
                            msgLog.length = 0;
                        });
                    } else if (response) {
                        dbConnection.connectionDB.commit((err) => {
                            if (err) {
                                dbConnection.connectionDB.rollback(() => {
                                    console.log(
                                        "COMMIT ERROR ROLLBACK INSERT familiaNivel2 :>> ",
                                        err,
                                    );
                                });
                            } else {
                                const status = globalFunctions.statusMsg(1);
                                msgLog.length = 0;
                                msgLog.push(status);
                                res.json(msgLog);
                                msgLog.length = 0;
                            }
                        });
                    }
                },
            );
        }
    });
};

familia_nivel_2_Controller.familia_nivel_2_update = (req, res) => {
    const familia_nivel_2 = req.body;

    if (!familia_nivel_2) {
        const status = gF.globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {
        console.table(familia_nivel_2);
        const query = "UPDATE familiaNivel2 SET descripcion = ?, idFamiliaNivel1 = ?, idNomenclatura = ?, idCentrosCosto = ?, idEmpresas = ?, updated_at = CURRENT_TIMESTAMP() WHERE id = ?";

        dbConnection.connectionDB.beginTransaction((err) => {
            if (err) {
                console.error("TRANSACTION ERROR :>> ", err);
            } else {
                dbConnection.connectionDB.query(
                    query, [
                        familia_nivel_2.descripcion,
                        familia_nivel_2.idFamiliaNivel1,
                        familia_nivel_2.idNomenclatura,
                        familia_nivel_2.idCentrosCosto,
                        familia_nivel_2.idEmpresas,
                        familia_nivel_2.id
                    ],
                    (error, response, result) => {
                        if (error) {
                            dbConnection.connectionDB.rollback(() => {
                                console.log("QUERY > ROLLBACK ERROR UPDATE familiaNivel2 :>> ", error);
                                const status = globalFunctions.statusMsg(0);
                                msgLog.length = 0;
                                msgLog.push(status);
                                res.json(msgLog);
                                msgLog.length = 0;
                            });
                        } else if (response) {
                            console.log("QUERY RESULT :>> ");
                            console.log(result);
                            dbConnection.connectionDB.commit((err) => {
                                if (err) {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log(
                                            "COMMIT ERROR ROLLBACK UPDATE familiaNivel2 :>> ",
                                            err,
                                        );
                                    });
                                } else {
                                    const status = globalFunctions.statusMsg(1);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                }
                            });
                        }
                    },
                );
            }
        });
    }
};

module.exports.familia_nivel_2_Controller = familia_nivel_2_Controller;