const dbConnection = require("../db/connection");
const globalFun = require("./globalfuntions.controller");
const XLSX = require("xlsx");
const carbone = require("carbone");
const fs = require("fs");
const path = require("path");
const { logger_data, logger_msg } = require('../config/utils');
const express = require("express");
const app = express();
const { LOCAL_STORAGE } = require("../constants/local-storage-constants");

const reportes_fecha = "reportes_fecha",
	reportes_fecha_detalle = "reportes_fecha_detalle",
	reportes_producto = "reportes_producto",
	reportes_factura = "reportes_factura",
	reportes_factura_amsu = "reportes_factura_amsu",
	reportes_factura_kreative = "reportes_factura_kreative";

reportesController = {};

let msgLog = [];

reportesController.reportesTipo_list = (req, res) => {
	const rt = req.body;
	const query = "SELECT * FROM reportesTipo WHERE idEmpresas=?;";
	dbConnection.connectionDB.query(query, [rt.idEmpresas], (error, results, response) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}

reportesController.reportesTipo_detail = (req, res) => {
	const rt = req.body;
	const query = "SELECT * FROM reportesTipo WHERE id = ? AND idEmpresas=? LIMIT 1;"
	dbConnection.connectionDB.query(query, [rt.id, rt.idEmpresas], (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}


reportesController.reportesInfo_list = (req, res) => {
	const ri = req.body;
	// const query = "SELECT * FROM reportesInfo WHERE idEmpresas=?;";
	const query = "	SELECT ri.id, ri.descripcion, ri.query, ri.reportePlantilla, ri.idReportesTipo, rt.descripcion as idReportesTipoDescripcion, ri.idArchivosExtensiones, ae.descripcion as idArchivosExtensionesDescripcion, ri.idEmpresas FROM reportesInfo ri LEFT JOIN reportesTipo rt ON rt.id = ri.idReportesTipo LEFT JOIN archivosExtensiones ae ON ae.id = ri.idArchivosExtensiones WHERE ri.idEmpresas = ?;";
	dbConnection.connectionDB.query(query, [ri.idEmpresas], (error, results, response) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}

reportesController.reportesInfo_detail = (req, res) => {
	const ri = req.body;
	console.table(cliente);
	const query = "SELECT * FROM reportesInfo WHERE id = ? AND idEmpresas=? LIMIT 1;"
	dbConnection.connectionDB.query(query, [ri.id, ri.idEmpresas], (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}

reportesController.reporte_create = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const reporteInfo = req.body;

	if (!reporteInfo) {
		msgLog.push("No hay información a solicitar.");
		res.status(200).json(msgLog);
		msgLog.length = 0;
	} else if (reporteInfo) {
		const fechaInicioTD = Date.parse(reporteInfo.fechaInicio);
		const fechaFinTD = Date.parse(reporteInfo.fechaFin);

		if (fechaInicioTD <= fechaFinTD) {
			const empresaInfo = "SELECT * FROM empresas;";
			let empresaNombre;
			dbConnection.connectionDB.query(empresaInfo, (error, results) => {
				if (error) {
					console.log(error);
				} else if (results.length > 0) {
					empresaNombre = results[0].nombreComercial;
					dbConnection.connectionDB.query(
						reporteInfo.query, [reporteInfo.fechaInicio, reporteInfo.fechaFin],
						(error, results) => {
							if (error) {
								console.log(error);
							} else if (results.length > 0) {
								let arrayReporte = JSON.stringify(results);
								let arrayReporteNew = JSON.parse(arrayReporte);

								let dateNhour = null;
								let fileName = null;
								let arrayReporteNewv2 = null;
								let sumCant = null;
								let sumTotal = null;
								let sumDescuento = null;
								let matrixReporte = null;

								switch (reporteInfo.idReportesTipoDescripcion) {
									case reportes_fecha:
										dateNhour = globalFun.globalFunctions.dateFunction("dateNhour");

										//* Ubicación y nombre del archivo
										fileName = globalFunctions.filenameReporte(reportes_fecha, dateNhour, reporteInfo.idArchivosExtensionesDescripcion);

										// * Adicion de numero de registros a el arreglo
										arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(arrayReporteNew);

										// * SUMA DEL "total:" DE CADA ARREGLO
										sumTotal = globalFun.globalFunctions.sumaElemento(arrayReporteNew, "total");

										// * Procesamiento de la matriz
										matrixReporte = globalFunctions.datosReporteMatrix(
											empresaNombre,
											reporteInfo.fechaInicio,
											reporteInfo.fechaFin,
											"",
											sumTotal,
											arrayReporteNewv2
										);
										break;
									case reportes_fecha_detalle:
										dateNhour = globalFun.globalFunctions.dateFunction("dateNhour");

										//* Ubicación y nombre del archivo
										fileName = globalFunctions.filenameReporte(reportes_fecha_detalle, dateNhour, reporteInfo.idArchivosExtensionesDescripcion);

										// * Adicion de numero de registros a el arreglo
										arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(arrayReporteNew);

										// * SUMA DEL "cant:" DE CADA ARREGLO
										sumCant = globalFunctions.sumaElemento(arrayReporteNew, "cant");

										// * SUMA DEL "total:" DE CADA ARREGLO
										sumTotal = globalFunctions.sumaElemento(arrayReporteNew, "total");

										// * Procesamiento de la matriz
										matrixReporte = globalFunctions.datosReporteMatrix(
											empresaNombre,
											reporteInfo.fechaInicio,
											reporteInfo.fechaFin,
											sumCant,
											sumTotal,
											arrayReporteNewv2,
										);
										break;
									case reportes_producto:
										dateNhour = globalFun.globalFunctions.dateFunction("dateNhour");

										//* Ubicación y nombre del archivo
										fileName = globalFunctions.filenameReporte(reportes_producto, dateNhour, reporteInfo.idArchivosExtensionesDescripcion);

										// * Adicion de numero de registros a el arreglo
										arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(arrayReporteNew);

										// * SUMA DEL "cant:" DE CADA ARREGLO
										sumCant = globalFunctions.sumaElemento(arrayReporteNew, "cant");

										// * SUMA DEL "total:" DE CADA ARREGLO
										sumTotal = globalFunctions.sumaElemento(arrayReporteNew, "total");

										// * Procesamiento de la matriz
										matrixReporte = globalFunctions.datosReporteMatrix(
											empresaNombre,
											reporteInfo.fechaInicio,
											reporteInfo.fechaFin,
											sumCant,
											sumTotal,
											arrayReporteNewv2,
										);
										break;
									case reportes_factura:
										dateNhour = globalFun.globalFunctions.dateFunction("dateNhour");

										//* Ubicación y nombre del archivo
										fileName = globalFunctions.filenameReporte(reportes_factura, dateNhour, reporteInfo.idArchivosExtensionesDescripcion);

										// * Adicion de numero de registros a el arreglo
										arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(arrayReporteNew);

										// * SUMA DEL "cant:" DE CADA ARREGLO
										sumCant = globalFunctions.sumaElemento(arrayReporteNew, "cant");

										// * SUMA DEL "total:" DE CADA ARREGLO
										sumTotal = globalFunctions.sumaElemento(arrayReporteNew, "total");

										// * SUMA DEL "descuento:" DE CADA ARREGLO
										sumDescuento = globalFunctions.sumaElemento(arrayReporteNew, "descuento");

										// * Procesamiento de la matriz
										matrixReporte = globalFunctions.datosReporteMatrix(
											empresaNombre,
											reporteInfo.fechaInicio,
											reporteInfo.fechaFin,
											"",
											"",
											arrayReporteNewv2,
										);
										break;
									case reportes_factura_kreative:
										dateNhour = globalFun.globalFunctions.dateFunction("dateNhour");

										//* Ubicación y nombre del archivo
										fileName = globalFunctions.filenameReporte(reportes_factura_kreative, dateNhour, reporteInfo.idArchivosExtensionesDescripcion);

										// * Adicion de numero de registros a el arreglo
										arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(arrayReporteNew);

										// * Procesamiento de la matriz
										matrixReporte = globalFunctions.datosReporteMatrix(
											empresaNombre,
											reporteInfo.fechaInicio,
											reporteInfo.fechaFin,
											"",
											"",
											arrayReporteNewv2,
										);
										break;
									case reportes_factura_amsu:
										dateNhour = globalFun.globalFunctions.dateFunction("dateNhour");

										//* Ubicación y nombre del archivo
										fileName = globalFunctions.filenameReporte(reportes_factura_amsu, dateNhour, reporteInfo.idArchivosExtensionesDescripcion);
										console.log(arrayReporteNew)
										// * Adicion de numero de registros a el arreglo
										arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(arrayReporteNew);
										console.log(arrayReporteNewv2);

										// * Procesamiento de la matriz
										matrixReporte = globalFunctions.datosReporteMatrix(
											empresaNombre,
											reporteInfo.fechaInicio,
											reporteInfo.fechaFin,
											"",
											"",
											arrayReporteNewv2,
										);
										break;
								}

								console.log("matrixReporte :>> ", matrixReporte);

								switch (reporteInfo.idArchivosExtensionesDescripcion) {
									case "xlsx":
										carbone.render(
											path.join(
												__dirname,
												"..",
												"assets",
												"docs",
												reporteInfo.reportePlantilla,
											),
											matrixReporte,
											function (err, result) {
												if (err) {
													console.log("Error :>> ", err);
													globalFunctions.logger(logger_data(req), 'error', `${logger_msg.consulta.error} ${err}`)
													msgLog.push("Error al procesar reporte.");
													res.status(200).json(msgLog);
													msgLog.length = 0;
												}
												fs.writeFile(
													fileName,
													result,
													() => {
														msgLog.push(fileName);
														res.status(200).json(msgLog);
														app.set(LOCAL_STORAGE.KEYS.NOMBRE_REPORTE, fileName);
														msgLog.length = 0;
													},
												);
											},
										);
										break;
								}
							} else {
								msgLog.push("Sin resultados.");
								res.status(200).send({ msg: "Sin resultados." });
								msgLog.length = 0;
							}
						},
					);
				}
			});
		} else {
			msgLog.push("Rango de fechas no válido.");
			// res.status(200).json(msgLog);
			res.status(200).send({ msg: "Rango de fechas no válido." });
			msgLog.length = 0;
		}
	}
}

reportesController.reporteFecha = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const reporteInfo = req.body;

	if (!reporteInfo) {
		msgLog.push("No hay información a solicitar.");
		res.status(200).json(msgLog);
		msgLog.length = 0;
	} else if (reporteInfo) {
		const fechaInicioTD = Date.parse(reporteInfo.fechaInicio);
		const fechaFinTD = Date.parse(reporteInfo.fechaFin);

		if (fechaInicioTD <= fechaFinTD) {
			const empresaInfo = "SELECT * FROM empresas;";
			let empresaNombre;
			dbConnection.connectionDB.query(empresaInfo, (error, results) => {
				if (error) {
					console.log(error);
				} else if (results.length > 0) {
					empresaNombre = results[0].nombreComercial;
					const reporteFechaQuery =
						"SELECT DATE_FORMAT(fechaFactura, '%Y-%m-%d') AS fecha, SUM(total) AS total FROM ventas WHERE idSucursales = 1 AND idEmpresas = 1 AND DATE(ventas.created_at) BETWEEN DATE(?) and  DATE(?) GROUP BY fecha;";

					dbConnection.connectionDB.query(
						reporteFechaQuery,
						[reporteInfo.fechaInicio, reporteInfo.fechaFin],
						(error, results) => {
							if (error) {
								console.log(error);
							} else if (results.length > 0) {
								let arrayReporte = JSON.stringify(results);
								let arrayReporteNew = JSON.parse(arrayReporte);

								const dateNhour = globalFun.globalFunctions.dateFunction(
									"dateNhour",
								);

								//* Ubicación y nombre del archivo
								const fileName = globalFunctions.filenameReporte(
									reportes_fecha,
									dateNhour,
									reporteInfo.extReporte,
								);

								// * Adicion de numero de registros a el arreglo
								let arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(
									arrayReporteNew,
								);

								// * SUMA DEL "total:" DE CADA ARREGLO
								let sumTotal = globalFun.globalFunctions.sumaElemento(
									arrayReporteNew, "total"
								);

								// * Procesamiento de la matriz
								let matrixReporte = globalFunctions.datosReporteMatrix(
									empresaNombre,
									reporteInfo.fechaInicio,
									reporteInfo.fechaFin,
									"",
									sumTotal,
									arrayReporteNewv2,
								);

								console.log(
									"matrixReporte :>> ",
									matrixReporte,
								);

								switch (reporteInfo.extReporte) {
									case "xlsx":
										carbone.render(
											// "assets/docs/Template_ReporteFecha.xlsx",
											path.join(
												__dirname,
												"..",
												"assets",
												"docs",
												"Template_ReporteFecha.xlsx",
											),
											matrixReporte,
											function (err, result) {
												if (err) {
													console.log(
														"Error :>> ",
														err,
													);
													globalFunctions.logger(logger_data(req), 'error', `${logger_msg.consulta.error} ${err}`)
													msgLog.push("Error al procesar reporte.");
													res.status(200).json(msgLog);
													msgLog.length = 0;
												}
												fs.writeFile(
													fileName,
													result,
													() => {
														msgLog.push(fileName);
														res.status(200).json(
															msgLog,
														);
														app.set(LOCAL_STORAGE.KEYS.NOMBRE_REPORTE, fileName);
														msgLog.length = 0;
													},
												);
											},
										);
										break;
								}
							} else {
								msgLog.push("Sin resultados.");
								// res.status(200).json(msgLog);
								res.status(200).send({ msg: "Sin resultados." });
								msgLog.length = 0;
							}
						},
					);
				}
			});
		} else {
			msgLog.push("Rango de fechas no válido.");
			// res.status(200).json(msgLog);
			res.status(200).send({ msg: "Rango de fechas no válido." });
			msgLog.length = 0;
		}
	}
};

reportesController.reporteFechaDetallado = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const reporteInfo = req.body;

	if (!reporteInfo) {
		msgLog.push("No hay información a solicitar.");
		res.status(200).json(msgLog);
		msgLog.length = 0;
	} else if (reporteInfo) {
		const fechaInicioTD = Date.parse(reporteInfo.fechaInicio);
		const fechaFinTD = Date.parse(reporteInfo.fechaFin);

		if (fechaInicioTD <= fechaFinTD) {
			const empresaInfo = "SELECT * FROM empresas;";
			let empresaNombre;
			dbConnection.connectionDB.query(empresaInfo, (error, results) => {
				if (error) {
					console.log(error);
				} else if (results.length > 0) {
					empresaNombre = results[0].nombreComercial;
					const reporteFechaDetalladoQuery =
						"SELECT DATE_FORMAT(ventas.created_at, '%Y-%m-%d') AS fecha, productos.sku, familiaNivel2.descripcion, productos.descLArga AS nombre, SUM(cantidad) AS cant, SUM(ventasDetalle.total) AS total FROM ventasDetalle, ventas, productos, familiaNivel2 WHERE ventas. idSucursales = 1 AND ventas.idEmpresas = 1 AND idVentas = ventas.id AND productos.id = ventasDetalle.idProductos AND familiaNivel2.idFamiliaNivel1 = productos.idFamiliaNivel1 AND familiaNivel2.id = productos.idFamiliaNivel2 AND DATE(ventas.created_at) BETWEEN DATE(?) and  DATE(?) GROUP BY fecha , productos.sku, idFamiliaNivel2;";
					dbConnection.connectionDB.query(
						reporteFechaDetalladoQuery,
						[reporteInfo.fechaInicio, reporteInfo.fechaFin],
						(error, results) => {
							if (error) {
								console.log(error);
							} else if (results.length > 0) {
								let arrayReporte = JSON.stringify(results);
								let arrayReporteNew = JSON.parse(arrayReporte);

								const dateNhour = globalFun.globalFunctions.dateFunction(
									"dateNhour",
								);

								//* Ubicación y nombre del archivo
								const fileName = globalFunctions.filenameReporte(
									reportes_fecha_detalle,
									dateNhour,
									reporteInfo.extReporte,
								);

								// * Adicion de numero de registros a el arreglo
								let arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(
									arrayReporteNew,
								);

								// * SUMA DEL "cant:" DE CADA ARREGLO
								let sumCant = globalFunctions.sumaElemento(
									arrayReporteNew, "cant"
								);

								// * SUMA DEL "total:" DE CADA ARREGLO
								let sumTotal = globalFunctions.sumaElemento(
									arrayReporteNew, "total"
								);

								// * Procesamiento de la matriz
								let matrixReporte = globalFunctions.datosReporteMatrix(
									empresaNombre,
									reporteInfo.fechaInicio,
									reporteInfo.fechaFin,
									sumCant,
									sumTotal,
									arrayReporteNewv2,
								);

								console.log(
									"matrixReporte :>> ",
									matrixReporte,
								);

								switch (reporteInfo.extReporte) {
									case "xlsx":
										carbone.render(
											path.join(
												__dirname,
												"..",
												"assets",
												"docs",
												"Template_ReporteFechaDetalle.xlsx",
											),
											matrixReporte,
											function (err, result) {
												if (err) {
													console.log(
														"Error :>> ",
														err,
													);
													msgLog.push(
														"Error al procesar reporte.",
													);
													res.status(200).json(
														msgLog,
													);
													msgLog.length = 0;
												}
												fs.writeFile(
													fileName,
													result,
													() => {
														msgLog.push(fileName);
														res.status(200).json(
															msgLog,
														);
														app.set(LOCAL_STORAGE.KEYS.NOMBRE_REPORTE, fileName);
														msgLog.length = 0;
													},
												);
											},
										);
										break;
								}
							} else {
								msgLog.push("Sin resultados.");
								// res.status(200).json(msgLog);
								res.status(200).send({ msg: "Sin resultados." });
								msgLog.length = 0;
							}
						},
					);
				}
			});
		} else {
			msgLog.push("Rango de fechas no válido.");
			res.status(200).send({ msg: "Rango de fechas no válido." });
			msgLog.length = 0;
		}
	}
};

reportesController.reporteProducto = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const reporteInfo = req.body;

	if (!reporteInfo) {
		msgLog.push("No hay información a solicitar.");
		res.status(200).json(msgLog);
		msgLog.length = 0;
	} else if (reporteInfo) {
		const fechaInicioTD = Date.parse(reporteInfo.fechaInicio);
		const fechaFinTD = Date.parse(reporteInfo.fechaFin);

		if (fechaInicioTD <= fechaFinTD) {
			const empresaInfo = "SELECT * FROM empresas;";
			let empresaNombre;
			dbConnection.connectionDB.query(empresaInfo, (error, results) => {
				if (error) {
					console.log(error);
				} else if (results.length > 0) {
					empresaNombre = results[0].nombreComercial;
					const reporteProductoQuery =
						"SELECT productos.sku, familiaNivel2.descripcion, productos.descLArga AS nombre, ROUND(SUM(cantidad), 2) AS cant, ROUND(SUM(ventasDetalle.total), 2) AS total FROM ventasDetalle, ventas, productos, familiaNivel2 WHERE ventas.idSucursales = 1 AND ventas.idEmpresas = 1 AND idVentas = ventas.id AND productos.id = ventasDetalle.idProductos AND familiaNivel2.idFamiliaNivel1 = productos.idFamiliaNivel1 AND familiaNivel2.id = productos.idFamiliaNivel2 AND DATE(ventas.created_at) BETWEEN DATE(?) and  DATE(?) GROUP BY productos.sku, idFamiliaNivel2";
					dbConnection.connectionDB.query(
						reporteProductoQuery,
						[reporteInfo.fechaInicio, reporteInfo.fechaFin],
						(error, results) => {
							if (error) {
								console.error(error);
							} else if (results.length > 0) {
								let arrayReporte = JSON.stringify(results);
								let arrayReporteNew = JSON.parse(arrayReporte);
								console.table(arrayReporteNew);

								const dateNhour = globalFun.globalFunctions.dateFunction(
									"dateNhour",
								);

								//* Ubicación y nombre del archivo
								const fileName = globalFunctions.filenameReporte(
									reportes_producto,
									dateNhour,
									reporteInfo.extReporte,
								);

								// * Adicion de numero de registros a el arreglo
								let arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(
									arrayReporteNew,
								);

								// * SUMA DEL "cant:" DE CADA ARREGLO
								let sumCant = globalFunctions.sumaElemento(
									arrayReporteNew, "cant"
								);

								// * SUMA DEL "total:" DE CADA ARREGLO
								let sumTotal = globalFunctions.sumaElemento(
									arrayReporteNew, "total"
								);

								// * Procesamiento de la matriz
								let matrixReporte = globalFunctions.datosReporteMatrix(
									empresaNombre,
									reporteInfo.fechaInicio,
									reporteInfo.fechaFin,
									sumCant,
									sumTotal,
									arrayReporteNewv2,
								);

								console.log(
									"matrixReporte :>> ",
									matrixReporte,
								);

								switch (reporteInfo.extReporte) {
									case "xlsx":
										carbone.render(
											path.join(
												__dirname,
												"..",
												"assets",
												"docs",
												"Template_ReporteProducto.xlsx",
											),
											matrixReporte,
											function (err, result) {
												if (err) {
													console.log(
														"Error :>> ",
														err,
													);
													msgLog.push(
														"Error al procesar reporte.",
													);
													res.status(200).json(
														msgLog,
													);
													msgLog.length = 0;
												}
												fs.writeFile(
													fileName,
													result,
													() => {
														msgLog.push(fileName);
														res.status(200).json(
															msgLog,
														);
														app.set(LOCAL_STORAGE.KEYS.NOMBRE_REPORTE, fileName);
														msgLog.length = 0;
													},
												);
											},
										);
										break;
								}
							} else {
								msgLog.push("Sin resultados.");
								// res.status(200).json(msgLog);
								res.status(200).send({ msg: "Sin resultados." });
								msgLog.length = 0;
							}
						},
					);
				}
			});
		} else {
			msgLog.push("Rango de fechas no válido.");
			// res.status(200).json(msgLog);
			res.status(200).send({ msg: "Rango de fechas no válido." });
			msgLog.length = 0;
		}
	}
};

reportesController.reporteFactura = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const reporteInfo = req.body;
	console.log("req.body :>> ", req.body);
	if (!reporteInfo) {
		msgLog.push("No hay información a solicitar.");
		res.status(200).json(msgLog);
		msgLog.length = 0;
	} else if (reporteInfo) {
		console.log("entra :>> ");
		const fechaInicioTD = Date.parse(reporteInfo.fechaInicio);
		const fechaFinTD = Date.parse(reporteInfo.fechaFin);

		if (fechaInicioTD <= fechaFinTD) {
			const empresaInfo = "SELECT * FROM empresas;";
			let empresaNombre;
			dbConnection.connectionDB.query(empresaInfo, (error, results) => {
				if (error) {
					console.log(error);
				} else if (results.length > 0) {
					empresaNombre = results[0].nombreComercial;
					console.log("empresaNombre :>> ", empresaNombre);
					// old query
					// const reporteFacturaQuery =
					// 	"SELECT serie, correlativo, autorizacionFEL, fechaFactura, nit, nombre, subtotal, iva, valorFactura FROM ventas WHERE tipoTransaccion = 1 AND fechaFactura >= CAST(? AS DATE) AND fechaFactura <= CAST(? AS DATE);";
					const reporteFacturaQuery =
						"SELECT serie, correlativo, autorizacionFEL, DATE_FORMAT(fechaFactura, '%Y-%m-%d') AS fechaFactura, nit, nombre, ROUND(subtotal, 2) AS subtotal, ROUND(iva, 2) AS iva, ROUND(descuento, 2) AS descuento, ROUND(valorFactura, 2) AS valorFactura FROM ventas WHERE autorizacionFEL is not null AND fechaFactura >= CAST(? AS DATE) AND fechaFactura <= CAST(? AS DATE);";
					dbConnection.connectionDB.query(
						reporteFacturaQuery,
						[reporteInfo.fechaInicio, reporteInfo.fechaFin],
						(error, results) => {
							if (error) {
								console.log(error);
							} else if (results.length > 0) {
								let arrayReporte = JSON.stringify(results);
								let arrayReporteNew = JSON.parse(arrayReporte);

								const dateNhour = globalFun.globalFunctions.dateFunction(
									"dateNhour",
								);

								//* Ubicación y nombre del archivo
								const fileName = globalFunctions.filenameReporte(
									reportes_factura,
									dateNhour,
									reporteInfo.extReporte,
								);

								// * Adicion de numero de registros a el arreglo
								let arrayReporteNewv2 = globalFunctions.sumaCantidadRegistros(
									arrayReporteNew,
								);

								// * SUMA DEL "total:" DE CADA ARREGLO
								let sumCant = globalFunctions.sumaElemento(
									arrayReporteNew, "cant"
								);

								// * SUMA DEL "total:" DE CADA ARREGLO
								let sumTotal = globalFunctions.sumaElemento(
									arrayReporteNew, "total"
								);

								// * SUMA DEL "descuento:" DE CADA ARREGLO
								let sumDescuento = globalFunctions.sumaElemento(arrayReporteNew, "descuento");

								// * Procesamiento de la matriz
								let matrixReporte = globalFunctions.datosReporteMatrix(
									empresaNombre,
									reporteInfo.fechaInicio,
									reporteInfo.fechaFin,
									"",
									"",
									arrayReporteNewv2,
								);
								console.log(
									"matrixReporte :>> ",
									matrixReporte,
								);

								switch (reporteInfo.extReporte) {
									case "xlsx":
										carbone.render(
											path.join(
												__dirname,
												"..",
												"assets",
												"docs",
												"Template_ReporteFactura.xlsx",
											),
											matrixReporte,
											function (err, result) {
												if (err) {
													console.log(
														"Error :>> ",
														err,
													);
													msgLog.push(
														"Error al procesar reporte.",
													);
													res.status(200).json(
														msgLog,
													);
													msgLog.length = 0;
												}
												fs.writeFile(
													fileName,
													result,
													() => {
														msgLog.push(fileName);
														res.status(200).json(
															msgLog,
														);
														app.set(LOCAL_STORAGE.KEYS.NOMBRE_REPORTE, fileName);
														msgLog.length = 0;
													},
												);
											},
										);
										break;
								}
							} else {
								msgLog.push("Sin resultados.");
								// res.status(200).json(msgLog);
								res.status(200).send({ msg: "Sin resultados." });
								msgLog.length = 0;
							}
						},
					);
				}
			});
		} else {
			msgLog.push("Rango de fechas no válido.");
			// res.status(200).json(msgLog);
			res.status(200).send({ msg: "Rango de fechas no válido." });
			msgLog.length = 0;
		}
	}
};

reportesController.downloadReporte = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
	globalFunctions.logger(logger_data(req), 'info', `Documento descargado. ${app.get(LOCAL_STORAGE.KEYS.NOMBRE_REPORTE)}`);
	res.status(200).download(app.get(LOCAL_STORAGE.KEYS.NOMBRE_REPORTE));
	app.set(LOCAL_STORAGE.KEYS.NOMBRE_REPORTE, '')
};

module.exports.reportesController = reportesController;
